% program spocita cislo pi pomoci for a parfor
%  pouzivat se bude geometricka metoda se ctvrtkruhem
function MCparforPi()
clear;clc;
Ns = 1e2;
Ni=1e6;
Nmax=5e7;
Nl = length(Ns:Ni:Nmax);
vals = zeros(4,Nl);
iter=1;
for N= Ns:Ni:Nmax    
    % -----------------vektorove---------------
    tic;
    piMCv = Vektorove(N);
    endv = toc;
    % --------------seriove--------------------
     tic;
%     piMCs = Seriove(N);
     ends = toc;
    % --------------paralelne--------------------
    tic;
    piMCs = paralelne(N);
    endp = toc;
    
    vals(1,iter) = N;
    vals(2,iter) = endv;
    vals(3,iter) = ends;
    vals(4,iter) = endp;
    iter=iter+1;
    disp(N)
end

h= figure;
plot(vals(1,:),vals(2,:),'-*r'); hold on; % vektorove
% plot(vals(1,:),vals(3,:),'-*b'); hold on; % seriove
plot(vals(1,:),vals(4,:),'-*g'); hold on; % paralelne
xlabel('pocet Monte Carlo pokusu N');
ylabel('Cas vypoctu');
% legend('Vektorove','Seriove','Paralelne');
legend('Vektorove','Paralelne');
end

function piMC = Vektorove(N)
xp = rand(1,N);
yp = rand(1,N);
n_prime = (xp.*xp + yp.*yp) <= 1.0;
piMC = (4.0*sum(n_prime))/double(N);
end


function piMC = Seriove(N)

n_prime = 0;

for i=1:N
    r = rand(1,2);
    delka = sum(r.*r);
    if(delka <= 1) n_prime = n_prime+1;end
end
piMC = (4.0*n_prime)/double(N);

end

function piMC = paralelne(N)
%  matlabpool je jiz spusteny
n_prime=0;
parfor i=1:N
    
    xp = rand;
    yp = rand;
    delka = xp*xp + yp*yp;
    if(delka <= 1) n_prime = n_prime+1;end
end

piMC = (4.0*n_prime)/double(N);

end


