function MaticePrumer2()
clc; close all; clear all;
N = 50; % velikost matice

Ncs = 5;Nci = 50;Nce = 5e2;
Nl = length(Ncs:Nci:Nce);
vals = zeros(3,Nl);
Nk = 20; % pocet pokusu v kazdem behu

% nahodna bitmapa
A = GenerujMatici(N);
A1 = A;

iter = 1;
for Nc = Ncs:Nci:Nce
    
tic;
% seriovy vypocet
for npok = 1:Nc
    Vektory = zeros(Nk,5); % nejblizsi sousedy
    [Vektory,xp,yp]=GenerujVektor(Nk,Vektory,A1,N);
    [A1] = PrumerHodnot(Vektory,A1,xp,yp,Nk);
end
ends = toc;

A2 = A;
tic;
% paralelni vypocet
for npok = 1:Nc
[A2] = PrumerPar(A2,N,Nk);
end
endpar1 = toc;

A3 = A;
tic;
for npok = 1:Nc
[A3] = PrumerPar2(A3,N,Nk);
end
endpar2 = toc;

vals(1,iter)=Nc;
vals(2,iter)=ends;
vals(3,iter)=endpar1;
vals(4,iter)=endpar2;
iter = iter+1;
disp(Nc)
end

% Kresli(A,A1,A2,N)
  KresliVals(vals)
end


function A = GenerujMatici(N)
A=255*randi([0,1],N,N);
end

function [Vektory,xp,yp]=GenerujVektor(Nk,Vektory,A,N)

% generuj nahodne pozice
xp = randi([2,N-1],1,Nk);
yp = randi([2,N-1],1,Nk);

for i = 1:Nk % pres vsechny nahodne pozice
    x=xp(i);
    y=yp(i);
    
    xd = x-1;
    xu = x+1;
    yd = y-1;
    yu = y+1;
    
    Vektory(i,1) = A(x,y); %x,y
    Vektory(i,2) = A(x,yu);%x,y+1
    Vektory(i,3) = A(x,yd);%x,y-1
    Vektory(i,4) = A(xu,y);%x+1,y
    Vektory(i,5) = A(xd,y);%x-1,y
    
end




end

function [A] = PrumerHodnot(Vektory,A,xp,yp,Nk)

Sumy = sum(Vektory,2);

for i=1:Nk % zapis strednich hodnot
    A(xp(i),yp(i))  = Sumy(i)/5.;
end

end

function A = PrumerPar(A,N,Nk)

% generuj nahodne pozice
xp = randi([2,N-1],1,Nk);
yp = randi([2,N-1],1,Nk);
Sumy = zeros(1,Nk);

parfor i = 1:Nk % pres vsechny nahodne pozice
    Vektory = zeros(1,5); % nejblizsi sousedy    
    x=xp(i);
    y=yp(i);
    
    xd = x-1;
    xu = x+1;
    yd = y-1;
    yu = y+1;
    
    Vektory(1) = A(x,y); %x,y
    Vektory(2) = A(x,yu);%x,y+1
    Vektory(3) = A(x,yd);%x,y-1
    Vektory(4) = A(xu,y);%x+1,y
    Vektory(5) = A(xd,y);%x-1,y        
    Sumy(i) = sum(Vektory);        
end

for i=1:Nk    
    A(xp(i),yp(i))  = Sumy(i)/5.;
end

end

function A = PrumerPar2(A,N,Nk)

% generuj nahodne pozice
xp = randi([2,N-1],1,Nk);
yp = randi([2,N-1],1,Nk);
Sumy = zeros(1,Nk);
Vektory = zeros(Nk,5);

for i = 1:Nk % pres vsechny nahodne pozice
    x=xp(i);
    y=yp(i);
    
    xd = x-1;
    xu = x+1;
    yd = y-1;
    yu = y+1;
    
    Vektory(i,1) = A(x,y); %x,y
    Vektory(i,2) = A(x,yu);%x,y+1
    Vektory(i,3) = A(x,yd);%x,y-1
    Vektory(i,4) = A(xu,y);%x+1,y
    Vektory(i,5) = A(xd,y);%x-1,y
    
end

parfor i = 1:Nk % pres vsechny nahodne pozice     
    Sumy(i) = sum(Vektory(i,:));        
end

for i=1:Nk    
    A(xp(i),yp(i))  = Sumy(i)/5.;
end

end

function KresliVals(vals)

h= figure;
plot(vals(1,:),vals(2,:),'-*r','LineWidth',2); hold on; % det funkce
plot(vals(1,:),vals(3,:),'-*b','LineWidth',2); hold on; % seriove Laplace
plot(vals(1,:),vals(4,:),'-*g','LineWidth',2); hold on; % paralelne Laplace
xlabel('Pocet pokusu N');
ylabel('Cas vypoctu');
% legend('Vektorove','Seriove','Paralelne');
legend('Filtrace seriove)','Filtrace paralelne 1','Filtrace paralelne 2');

end



function Kresli(A,A1,A2, N)

h1 = figure;
subplot(2,2,1)
I = mat2gray(A);
imshow(I)

subplot(2,2,2)
I = mat2gray(A1);
imshow(I)

% histogramy
A = reshape(A,1,N*N);
A1 = reshape(A1,1,N*N);
[nel,xcenter] = hist(A);
[nel1,xcenter1] = hist(A1);

subplot(2,2,3)
bar(xcenter,nel)
xlabel('N')
ylabel('P(N)')


subplot(2,2,4)
bar(xcenter1,nel1)
xlabel('N')
ylabel('P(N)')



end


