function Lap_Matrix()
close all; clc;
Ns = 2;
Ni=50;
Nmax=600;
Nl = length(Ns:Ni:Nmax);
vals = zeros(4,Nl);

N = Ns;
iter = 1;

while (N < Nmax)    
    [A] = generujMatici(N);
    
    % serial approach determinant
    tic;
    detA = det(A);
    ends = toc;
    % -----------------------------
    if(detA ~= 0)
        %  perform laplace series
        %  series performed for lines-loop over j
        tic;
        [detLapSerial] = LaplaceSeriesSerial(A,N);
        endLapSerial = toc;
        tic;
        [detLapPar] = LaplaceSeriesPar(A,N);
        endLapPar = toc;

        %write to field
        vals(1,iter) = N;
        vals(2,iter) = ends;
        vals(3,iter) = endLapSerial;
        vals(4,iter) = endLapPar;
        
        disp(N)
        N = N + Ni;
        iter = iter+1;                
    end
    
end

Kresli(vals)

end

function [A] = generujMatici(N)
min = -3;
max= 3;
A = randi([min,max],N);
end


function [detLap] = LaplaceSeriesSerial(A,N)
i=1; % loop over first line
Ai = A; % auxiliary matrix
detLap = 0.0d0;
for j = 1:N
    % create submatrix
    Ai(i,:) = [];
    Ai(:,j) = [];
    detLap = detLap + (-1.)^(i+j)*A(i,j)*det(Ai);
    Ai= A;
end
end


function [detLap] = LaplaceSeriesPar(A,N)
i=1; % loop over first line
detLap = 0.0d0;
parfor j = 1:N
    Ai = A; % auxiliary matrix
    % create submatrix
    Ai(i,:) = [];
    Ai(:,j) = [];
    detLap = detLap + (-1.)^(i+j)*A(i,j)*det(Ai);
end
end

function Kresli(vals)

h= figure;
plot(vals(1,:),vals(2,:),'-*r','LineWidth',2); hold on; % det funkce
plot(vals(1,:),vals(3,:),'-*b','LineWidth',2); hold on; % seriove Laplace
plot(vals(1,:),vals(4,:),'-*g','LineWidth',2); hold on; % paralelne Laplace
xlabel('Velikost matice N');
ylabel('Cas vypoctu');
% legend('Vektorove','Seriove','Paralelne');
legend('Funkce det(A)','Laplace seriove','Laplace paralelne');

end
